##PROJECT_GLOBAL_BEGIN
[Programs]
Count=1

[Misc Info]
Author=Damir
Company=Cybrotech Ltd
Version=1.2
EditTime=22068
CyProVersion=2.5.3

[Protection]
Level=0
Password=
##PROJECT_GLOBAL_END

##PROGRAM_BEGIN_1
#PROJECT_OPTIONS_BEGIN
[Program]
Name=New Program

[VCP]
I2CPriority=5
SendSource=1
SendAlloc=1
ProtectWithPasswd=0
Password=
IORefresh=3
ScanOverrunStopsProgram=1
Com2Mode=2
HSCMode=0
EthAbusEnable=1
EthModbusEnable=0
WANUrl=
PushEvent=0
PushUrl=
ModbusBaudrate=38400
ModbusParity=0
ModbusStopBits=1
ModbusDelay=20
ModbusDeviceAddress=1
ModbusPLCDataModel=2
ModbusAddress=0
ModbusSlaveCount=1
ModbusRegisterCount=1
ModbusCoilsArrayVar=
ModbusRegistersArrayVar=
PLCCoilVars=
PLCRegisterVars=
ModbusCoilAddresses=
ModbusRegisterAddresses=

[Misc Info]
MonitorHistorySpeed=10

[Hardware]
CPUUnit=4

[Net]
MasterNAD=-1
CurrentNAD=-1

[MonitorNet]
MasterNAD=-1

[Monitor01]
VarCount=24
VarName1=room_enable[0]
VarBase1=1
VarValue1=0
VarColor1=255
VarIndex1=0
VarName2=hvac_water_temperature
VarBase2=1
VarValue2=0
VarColor2=32768
VarIndex2=1
VarName3=outdoor_temperature
VarBase3=1
VarValue3=0
VarColor3=32768
VarIndex3=2
VarName4=outdoor_humidity
VarBase4=1
VarValue4=0
VarColor4=32768
VarIndex4=3
VarName5=outdoor_lightness
VarBase5=1
VarValue5=0
VarColor5=32768
VarIndex5=4
VarName6=room_motion[0]
VarBase6=1
VarValue6=0
VarColor6=32768
VarIndex6=5
VarName7=room_presence_preset[0]
VarBase7=1
VarValue7=0
VarColor7=32768
VarIndex7=6
VarName8=room_presence_reset[0]
VarBase8=1
VarValue8=0
VarColor8=32768
VarIndex8=7
VarName9=room_presence_timer[0].ET
VarBase9=1
VarValue9=0
VarColor9=32768
VarIndex9=8
VarName10=room_presence_timer[0].PT
VarBase10=1
VarValue10=0
VarColor10=32768
VarIndex10=9
VarName11=room_presence[0]
VarBase11=1
VarValue11=0
VarColor11=32768
VarIndex11=10
VarName12=hvac_mode
VarBase12=1
VarValue12=0
VarColor12=13209
VarIndex12=11
VarName13=room_setpoint[0]
VarBase13=1
VarValue13=0
VarColor13=13209
VarIndex13=12
VarName14=room_alt_setpoint
VarBase14=1
VarValue14=0
VarColor14=13209
VarIndex14=13
VarName15=bio_enable[0]
VarBase15=1
VarValue15=0
VarColor15=13209
VarIndex15=14
VarName16=bio_offset
VarBase16=1
VarValue16=0
VarColor16=13209
VarIndex16=15
VarName17=room_temperature[0]
VarBase17=1
VarValue17=0
VarColor17=13209
VarIndex17=16
VarName18=room_max_setpoint
VarBase18=1
VarValue18=0
VarColor18=13209
VarIndex18=17
VarName19=room_min_setpoint
VarBase19=1
VarValue19=0
VarColor19=13209
VarIndex19=18
VarName20=fc_limit[0]
VarBase20=1
VarValue20=0
VarColor20=8421376
VarIndex20=19
VarName21=fc_max[0]
VarBase21=1
VarValue21=0
VarColor21=8421376
VarIndex21=20
VarName22=fc_max_timer[0].ET
VarBase22=1
VarValue22=0
VarColor22=8421376
VarIndex22=21
VarName23=fc_speed[0]
VarBase23=1
VarValue23=0
VarColor23=8421376
VarIndex23=22
VarName24=fc_valve[0]
VarBase24=1
VarValue24=0
VarColor24=8421376
VarIndex24=23
#PROJECT_OPTIONS_END

#DMVARSLIST_BEGIN
#DMVARSLIST_END

#MASKS_BEGIN
#MASKS_END

#CODE_BEGIN
// AllocGroupList="User Variables", "I/O Variables", "Constants"
var retain
  face_index: int;
var_end;

var
  room_enable: ARRAY[0..9] OF bool;default=1;
  room_presence_preset: ARRAY[0..9] OF bool;
  room_presence_reset: ARRAY[0..9] OF bool;
  room_motion: ARRAY[0..9] OF bool;
  room_presence: ARRAY[0..9] OF bool;
  room_presence_timer: ARRAY[0..9] OF timer = ( PT:=300000; TYPE:=Pulse; BASE:=1000 );
  room_temperature: ARRAY[0..9] OF int;
  room_setpoint: ARRAY[0..9] OF int;default=225;
  room_min_setpoint: int;default=180;
  room_max_setpoint: int;default=250;
  room_alt_setpoint: int;default=180;
  sim_temperature: long;default=15000;
  bio_enable: ARRAY[0..9] OF bool;default=1;
  bio_offset: int;
  hvac_mode: int;default=1;
  hvac_water_temperature: int;default=652;
  fc_valve: ARRAY[0..9] OF bool;
  fc_max_timer: ARRAY[0..9] OF timer = ( PT:=60000; TYPE:=Pulse; BASE:=1000 );
  fc_limit: ARRAY[0..9] OF int;default=3;
  fc_max: ARRAY[0..9] OF bool;
  fc_speed: ARRAY[0..9] OF int;
  outdoor_temperature: int;default=101;
  outdoor_humidity: int;default=55;
  outdoor_lightness: int;default=85;
  room_light_0: ARRAY[0..9] OF bool;
  room_light_1: ARRAY[0..9] OF bool;
  room_light_2: ARRAY[0..9] OF bool;
  room_light_3: ARRAY[0..9] OF bool;
  daymin: int;
  work_beg: int;default=480;
  work_end: int;default=960;
var_end;

function main:void; language 'Structured Text';
// AllocGroupList="User Variables"
var constant
  ROOM = 0; // Room number (0..9) used for demo, should be the same as gadget registry setting RoomIndex.
var_end;

  function light_algo:void; language 'Structured Text';
  begin

      // turn lights off when room is disabled or presence becomes false

      if fn(room_enable[ROOM] & room_presence[ROOM]) then
        room_light_0[ROOM]:=0;
        room_light_1[ROOM]:=0;
        room_light_2[ROOM]:=0;
        room_light_3[ROOM]:=0;
      end_if;

      // relay output

      cybro_qx00:=room_light_0[ROOM];
      cybro_qx01:=room_light_1[ROOM];
      cybro_qx02:=room_light_2[ROOM];
      cybro_qx03:=room_light_3[ROOM];

  end;
  function offset_algo:void; language 'Structured Text';
  begin

      // calculate bio-offset according to diurnal variation of body temperature
      // http://en.wikipedia.org/wiki/normal_human_body_temperature

      bio_offset:=
       (daymin>=360 and daymin< 420)*(    10*(daymin-360)/ 60)+
       (daymin>=420 and daymin< 660)*( 10-20*(daymin-420)/240)+
       (daymin>=660 and daymin< 780)*(-10+20*(daymin-660)/120)+
       (daymin>=780 and daymin< 960)*( 10-20*(daymin-780)/180)+
       (daymin>=960 and daymin<1200)*(-10+10*(daymin-960)/240);

  end;
  function presence_algo:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    temp: bool;
  var_end;

  begin

      // reload presence timer with motion detector positive pulse

      if fp(room_motion[ROOM]) then
        room_presence_timer.in[ROOM]:=1;
        room_presence_timer.in[ROOM]:=0;
        room_presence_timer.et[ROOM]:=0;
      end_if;

      // reload presence timer if preset is active

      if room_presence_preset[ROOM] then
        room_presence_preset[ROOM]:=0;
        room_presence_timer.in[ROOM]:=1;
        room_presence_timer.in[ROOM]:=0;
        room_presence_timer.et[ROOM]:=0;
      end_if;

      // reset presence timer if reset is active

      if room_presence_reset[ROOM] then
        room_presence_reset[ROOM]:=0;
        room_presence_timer.q[ROOM]:=0;
      end_if;

      // reset timer value when inactive

      if fn(room_presence_timer.q[ROOM]) then
        room_presence_timer.et[ROOM]:=room_presence_timer.pt[ROOM];
      end_if;

      // room presence signal is output of presence timer

      room_presence[ROOM]:=room_presence_timer.q[ROOM];

  end;
  function heating_algo:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var constant
    DELTA_T1 = 5; // delta t for fan coil speed 1 [*0.1C]
    DELTA_T2 = 20; // delta t for fan coil speed 2 [*0.1C]
    DELTA_T3 = 50; // delta t for fan coil speed 3 [*0.1C]
  var_end;

  var
    delta_t: int; // difference between actual temperature and setpoint
    actual_setpoint: int; // currently used setpoint value
  var_end;

  begin

      // limit actual setpoint

      if room_setpoint[ROOM]>room_max_setpoint then
        room_setpoint[ROOM]:=room_max_setpoint;
      elsif room_setpoint[ROOM]<room_min_setpoint then
        room_setpoint[ROOM]:=room_min_setpoint;
      end_if;

      // choose actual or alternate setpoint

      if room_presence[ROOM] then // somebody in room, use main setpoint
        actual_setpoint:=room_setpoint[ROOM];
        if bio_enable[ROOM] then // use bio offset if enabled
          actual_setpoint:=actual_setpoint+bio_offset;
        end_if;
      else // room empty, use alternate setpoint
        actual_setpoint:=room_alt_setpoint;
      end_if;

      // 3-stage on/off algorithm, calculate delta t

      if hvac_mode=1 then // heating
        delta_t:=actual_setpoint-room_temperature[ROOM];
      elsif hvac_mode=2 then // cooling
        delta_t:=room_temperature[ROOM]-actual_setpoint;
      else
        delta_t:=0;
      end_if;

      // rising fan coil speed

      if fc_speed[ROOM]=0 then
        if delta_t>=DELTA_T1 then
          fc_speed[ROOM]:=1;
        end_if;
      elsif fc_speed[ROOM]=1 then
        if delta_t>=DELTA_T2 then
          fc_speed[ROOM]:=2;
        end_if;
      elsif fc_speed[ROOM]=2 then
        if delta_t>=DELTA_T3 then
          fc_speed[ROOM]:=3;
        end_if;
      end_if;

      // lowering fan coil speed

      if fc_speed[ROOM]=3 then
        if delta_t<=DELTA_T2 then
          fc_speed[ROOM]:=2;
        end_if;
      elsif fc_speed[ROOM]=2 then
        if delta_t<=DELTA_T1 then
          fc_speed[ROOM]:=1;
        end_if;
      elsif fc_speed[ROOM]=1 then
        if (-delta_t)>=DELTA_T1 then
          fc_speed[ROOM]:=0;
        end_if;
      end_if;

      // speed limit

      if fc_speed[ROOM]>fc_limit[ROOM] then
        fc_speed[ROOM]:=fc_limit[ROOM];
      end_if;

      // fan max timer

      if not(room_enable[ROOM]) then
        fc_max[ROOM]:=0;
      end_if;

      if fp(fc_max[ROOM]) then
        fc_max_timer.in[ROOM]:=1;
        fc_max_timer.in[ROOM]:=0;
        fc_max_timer.et[ROOM]:=0;
      end_if;

      if fn(fc_max[ROOM]) then
        fc_max_timer.q[ROOM]:=0;
      end_if;

      if fn(fc_max_timer.q[ROOM]) then
        fc_max[ROOM]:=0;
        fc_max_timer.et[ROOM]:=fc_max_timer.pt[ROOM];
      end_if;

      if fc_max[ROOM] then
        fc_speed[ROOM]:=3;
      end_if;

      // room enable

      if not(room_enable[ROOM]) then
        fc_speed[ROOM]:=0;
      end_if;

      // valve control

      if fc_speed[ROOM]<>0 then
        fc_valve[ROOM]:=1;
      else
        fc_valve[ROOM]:=0;
      end_if;

      // relay output

      if fc_speed[ROOM]=1 then
        cybro_qx05:=1;
        cybro_qx06:=0;
        cybro_qx07:=0;
      elsif fc_speed[ROOM]=2 then
        cybro_qx05:=0;
        cybro_qx06:=1;
        cybro_qx07:=0;
      elsif fc_speed[ROOM]=3 then
        cybro_qx05:=0;
        cybro_qx06:=0;
        cybro_qx07:=1;
      else
        cybro_qx05:=0;
        cybro_qx06:=0;
        cybro_qx07:=0;
      end_if;

  end;
  function simulation_algo:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    sim_delta: long;
  var_end;

  begin

      // simulate influence of heating/cooling

      if fp(clock_100ms) then
        sim_delta:=long(hvac_water_temperature)*100-sim_temperature;
        if fc_speed[ROOM]=0 then
          sim_delta:=sim_delta/20000;
        elsif fc_speed[ROOM]=1 then
          sim_delta:=sim_delta/3000;
        elsif fc_speed[ROOM]=2 then
          sim_delta:=sim_delta/2000;
        elsif fc_speed[ROOM]=3 then
          sim_delta:=sim_delta/1500;
        end_if;
        sim_temperature:=sim_temperature+sim_delta;
      end_if;

      // simulate influence of outside temperature

      if fp(clock_1s) then
        sim_delta:=long(outdoor_temperature)*100-sim_temperature;
        sim_delta:=sim_delta/250;
        sim_temperature:=sim_temperature+sim_delta;
      end_if;

      // use simulated temperature as measured

      room_temperature[ROOM]:=int(sim_temperature/100);

      // weintek fast-changing screen

      face_index:=(face_index+fp(clock_100ms)) mod 8;

  end;
begin
  /*******************************************************************
    Application:  MyOfficeDemo
    Requires:     CyBro-2E
    Description:  Demo application for MyOffice gadget, CyBro web server,
                  and weintek MT500 touch-screen panel. Heating/cooling
                  algorithm is fully functional, but room temperature is
                  simulated using outdoor and fan-coil water temperature.

    To run this application:

      1. Detect CyBro, set nad alias to 100 and send kernel
      2. Replace detected nad with 100, send program and run
      3. Double click to MyOfficeDemo.reg to setup gadget
      4. Start gadget

    Hardware:
      qx00-qx03: lights 1 to 4
      qx05-qx07: fan coil speed 1 to 3

    Note:
      Although variable arrays are allocated for 10 rooms, this demo
      is simulating a single room.
  *******************************************************************/

    daymin:=60*rtc_hour+rtc_min;

    light_algo(); // room lights
    offset_algo(); // calculating bio-offset
    presence_algo(); // room presence timer
    heating_algo(); // room heating/cooling
    simulation_algo(); // room simulation

end;
#CODE_END

#DESCRIPTION_BEGIN
#DESCRIPTION_END

##PROGRAM_END_1
